searchData={"items":[{"type":"module","title":"fanotify","doc":"A low-level Erlang interface to the Linux  fanotify  API. <span class=\"w\">  </span><span class=\"c1\">% Create a notification group.</span><span class=\"w\">\n  </span><span class=\"n\">Group</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"nc\">fanotify</span><span class=\"p\">:</span><span class=\"nf\">group</span><span class=\"p\" data-group-id=\"5616427110-1\">(</span><span class=\"p\" data-group-id=\"5616427110-1\">)</span><span class=\"p\">.</span><span class=\"w\">\n \n  </span><span class=\"c1\">% Observe create and delete events on files inside /tmp/dir1</span><span class=\"w\">\n  </span><span class=\"c1\">% and keep the file handle for later use.</span><span class=\"w\">\n  </span><span class=\"ss\">nil</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"nc\">fanotify</span><span class=\"p\">:</span><span class=\"nf\">mark</span><span class=\"p\" data-group-id=\"5616427110-2\">(</span><span class=\"n\">Group</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"s\">&quot;/tmp/dir1&quot;</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5616427110-3\">[</span><span class=\"ss\">add</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">onlydir</span><span class=\"p\" data-group-id=\"5616427110-3\">]</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5616427110-4\">[</span><span class=\"ss\">create</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">delete</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">ondir</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">event_on_child</span><span class=\"p\" data-group-id=\"5616427110-4\">]</span><span class=\"p\" data-group-id=\"5616427110-2\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"n\">Dir1Handle</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"nc\">fanotify</span><span class=\"p\">:</span><span class=\"nf\">file_handle</span><span class=\"p\" data-group-id=\"5616427110-5\">(</span><span class=\"s\">&quot;/tmp/dir1&quot;</span><span class=\"p\" data-group-id=\"5616427110-5\">)</span><span class=\"p\">.</span><span class=\"w\">\n \n  </span><span class=\"c1\">% Also observe create and delete events on files inside /tmp/dir2.</span><span class=\"w\">\n  </span><span class=\"ss\">nil</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"nc\">fanotify</span><span class=\"p\">:</span><span class=\"nf\">mark</span><span class=\"p\" data-group-id=\"5616427110-6\">(</span><span class=\"n\">Group</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"s\">&quot;/tmp/dir2&quot;</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5616427110-7\">[</span><span class=\"ss\">add</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">onlydir</span><span class=\"p\" data-group-id=\"5616427110-7\">]</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5616427110-8\">[</span><span class=\"ss\">create</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">delete</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">ondir</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">event_on_child</span><span class=\"p\" data-group-id=\"5616427110-8\">]</span><span class=\"p\" data-group-id=\"5616427110-6\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"n\">Dir2Handle</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"nc\">fanotify</span><span class=\"p\">:</span><span class=\"nf\">file_handle</span><span class=\"p\" data-group-id=\"5616427110-9\">(</span><span class=\"s\">&quot;/tmp/dir2&quot;</span><span class=\"p\" data-group-id=\"5616427110-9\">)</span><span class=\"p\">.</span><span class=\"w\">\n \n  </span><span class=\"c1\">% Receive filesystem events.</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"5616427110-10\">[</span><span class=\"p\" data-group-id=\"5616427110-11\">{</span><span class=\"ss\">event</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">EventType</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5616427110-12\">[</span><span class=\"p\" data-group-id=\"5616427110-13\">{</span><span class=\"ss\">dfid_name</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">Handle</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">File</span><span class=\"p\" data-group-id=\"5616427110-13\">}</span><span class=\"p\" data-group-id=\"5616427110-12\">]</span><span class=\"p\" data-group-id=\"5616427110-11\">}</span><span class=\"p\" data-group-id=\"5616427110-10\">]</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"nc\">fanotify</span><span class=\"p\">:</span><span class=\"nf\">read</span><span class=\"p\" data-group-id=\"5616427110-14\">(</span><span class=\"n\">Group</span><span class=\"p\" data-group-id=\"5616427110-14\">)</span><span class=\"p\">.</span><span class=\"w\">\n \n  </span><span class=\"k\">case</span><span class=\"w\"> </span><span class=\"n\">Handle</span><span class=\"w\"> </span><span class=\"k\">of</span><span class=\"w\">\n      </span><span class=\"n\">Dir1Handle</span><span class=\"w\"> </span><span class=\"p\">-&gt;</span><span class=\"w\">\n          </span><span class=\"nc\">io</span><span class=\"p\">:</span><span class=\"nf\">format</span><span class=\"p\" data-group-id=\"5616427110-15\">(</span><span class=\"s\">&quot;Received </span><span class=\"si\">~w</span><span class=\"s\"> event on /tmp/dir1/</span><span class=\"si\">~s</span><span class=\"si\">~n</span><span class=\"s\">&quot;</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5616427110-16\">[</span><span class=\"n\">EventType</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">File</span><span class=\"p\" data-group-id=\"5616427110-16\">]</span><span class=\"p\" data-group-id=\"5616427110-15\">)</span><span class=\"p\">;</span><span class=\"w\">\n      </span><span class=\"n\">Dir2Handle</span><span class=\"w\"> </span><span class=\"p\">-&gt;</span><span class=\"w\">\n          </span><span class=\"nc\">io</span><span class=\"p\">:</span><span class=\"nf\">format</span><span class=\"p\" data-group-id=\"5616427110-17\">(</span><span class=\"s\">&quot;Received </span><span class=\"si\">~w</span><span class=\"s\"> event on /tmp/dir2/</span><span class=\"si\">~s</span><span class=\"si\">~n</span><span class=\"s\">&quot;</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5616427110-18\">[</span><span class=\"n\">EventType</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">File</span><span class=\"p\" data-group-id=\"5616427110-18\">]</span><span class=\"p\" data-group-id=\"5616427110-17\">)</span><span class=\"w\">\n  </span><span class=\"k\">end</span><span class=\"p\">.</span><span class=\"w\">\n \n  </span><span class=\"c1\">% Close the notification group when done.</span><span class=\"w\">\n  </span><span class=\"ss\">nil</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"nc\">fanotify</span><span class=\"p\">:</span><span class=\"nf\">close</span><span class=\"p\" data-group-id=\"5616427110-19\">(</span><span class=\"n\">Group</span><span class=\"p\" data-group-id=\"5616427110-19\">)</span><span class=\"p\">.</span> https://man7.org/linux/man-pages/man7/fanotify.7.html This library focuses on receiving notifications for filesystem objects and does not support intercepting events.","ref":"fanotify.html"},{"type":"type","title":"fanotify.action/0","doc":"Action to perform on the notification group.","ref":"fanotify.html#t:action/0"},{"type":"function","title":"fanotify.close/1","doc":"Close the notification group, stopping the monitoring of events.","ref":"fanotify.html#close/1"},{"type":"type","title":"fanotify.event/0","doc":"Notification event.","ref":"fanotify.html#t:event/0"},{"type":"type","title":"fanotify.event_type/0","doc":"Type of events that should be affected by the specified action.","ref":"fanotify.html#t:event_type/0"},{"type":"opaque","title":"fanotify.file_handle/0","doc":"Filesystem object handle. Identifies the filesystem object that received the notification.","ref":"fanotify.html#t:file_handle/0"},{"type":"function","title":"fanotify.file_handle/1","doc":"Get the file handle for the filesystem object at the given path. A filesystem handle remains stable across calls, so you can use this to identify which filesystem object received a notification when monitoring multiple objects.","ref":"fanotify.html#file_handle/1"},{"type":"opaque","title":"fanotify.group/0","doc":"A fanotify group. Internally, this is represented as a file descriptor for the event queue associated with the group.","ref":"fanotify.html#t:group/0"},{"type":"type","title":"fanotify.info/0","doc":"Additional event information.","ref":"fanotify.html#t:info/0"},{"type":"function","title":"fanotify.mark/4","doc":"Add, remove, or modify a fanotify mark on a filesystem object. The caller must have read permissions on the filesystem object that is to be marked.","ref":"fanotify.html#mark/4"},{"type":"function","title":"fanotify.new/0","doc":"Create a fanotify group. Currently the notification class supported is  FAN_CLASS_NOTIF | FAN_REPORT_DFID_NAME , as the others require the  CAP_SYS_ADMIN  capability.","ref":"fanotify.html#new/0"},{"type":"function","title":"fanotify.read/1","doc":"Read the queued notification events on the notification group. Returns a list of queued  event() s containing  {event,[event_type()],[info()]} . info()  is a tuple containing  {Type, FileHandle, SubPath} , where  Type  is one of  dfid_name ,  new_dfid_name , or  old_dfid_name ,  FileHandle  is the file handle of the monitored filesystem object, and  SubPath  is the subpath of the file that changes (when the monitored object is a directory and  [ondir, event_on_child]  were specified in the  mark/4  call), or  \".\"  when the watched object itself changed. Generally an  event()  only contains one  info()  with type  dfid_name , except for the  rename  event which contains an  old_dfid_name  and a  new_dfid_name , respectively representing the old and the new name of the object that changed.","ref":"fanotify.html#read/1"},{"type":"extras","title":"fanotify","doc":"# fanotify\n\nA low-level Erlang interface to the Linux `fanotify` API.\n\nThis library **only works on Linux** and is **experimental**; I am not a great Erlang\nprogrammer and this is the first Erlang library I publish; let alone the first time\nI've written NIFs. Did I mention this library uses dirty NIFs?\n\nThe `0.x` version number is there for a reason. You have been warned.","ref":"readme.html"},{"type":"extras","title":"Build - fanotify","doc":"```shell\n$ rebar3 compile\n```","ref":"readme.html#build"},{"type":"extras","title":"Usage - fanotify","doc":"`fanotify` is an API that allows efficiently monitoring changes to many filesystem objects at once.\n\nIn practice, this means that you can monitor changes to files inside a set of directories\nwithout spawning an external `inotifywatch` process.\n\n```erlang\n% Create a notification group.\nGroup = fanotify:new().\n\n% Observe create and delete events on files inside /tmp/dir1\n% and keep the file handle for later use.\nnil = fanotify:mark(Group, \"/tmp/dir1\", [add, onlydir], [create, delete, ondir, event_on_child]).\nDir1Handle = fanotify:file_handle(\"/tmp/dir1\").\n\n% Also observe create and delete events on files inside /tmp/dir2.\nnil = fanotify:mark(Group, \"/tmp/dir2\", [add, onlydir], [create, delete, ondir, event_on_child]).\nDir2Handle = fanotify:file_handle(\"/tmp/dir2\").\n\n% Receive filesystem events.\n[{event, EventType, [{dfid_name, Handle, File}]}] = fanotify:read(Group).\n\ncase Handle of\n    Dir1Handle ->\n        io:format(\"Received ~w event on /tmp/dir1/~s~n\", [EventType, File]);\n    Dir2Handle ->\n        io:format(\"Received ~w event on /tmp/dir2/~s~n\", [EventType, File])\nend.\n\n% Close the notification group when done.\nnil = fanotify:close(Group).\n```","ref":"readme.html#usage"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2025, steenuil  \n\nPermission to use, copy, modify, and/or distribute this software for any\npurpose with or without fee is hereby granted, provided that the above\ncopyright notice and this permission notice appear in all copies.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\" AND THE AUTHOR DISCLAIMS ALL WARRANTIES\nWITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\nMERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\nANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\nWHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\nACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\nOR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}